︠47e2a036-f441-4ede-8e95-21475e75d97b︠
def dichotomous_search(f, a1, b1, eps, Delta):
    a = a1
    b = b1
    while b - a > eps:
        l = (a+b)/2 - Delta
        r = (a+b)/2 + Delta
        if f(l) <= f(r):
            b = r
        else:
            a = l
    return (a+b)/2


︡d18628db-eebc-4ab0-b035-3b5f7ef0340f︡
︠1cd02e4f-1e2d-4fff-9ff6-71e958fe3f50s︠
def golden_section(f, a1, b1, ell):
    alpha = 0.61803398874989
    a = a1
    b = b1
    l = a + (1 - alpha)*(b - a)
    r = a + alpha*(b - a)
    fl = f(l)
    fr = f(r)
    while b - a > ell:
        if fl > fr:
            a = l
            l = r
            r = a + alpha*(b - a)
            fl = fr
            fr = f(r)
        else:
            b = r
            r = l
            l = a + (1 - alpha)*(b - a)
            fr = fl
            fl = f(l)

    return (a+b)/2


︡d4f3bb34-1212-4046-923a-b84e1693baa9︡{"done":true}
︠a618a6b2-4606-488e-99f6-e690e3baea73s︠
def newtons_method(f, start, eps):
    fp = f.derivative()
    fpp = fp.derivative()
    x = start
    finished = false
    while not finished:
        newx = x - fp(x) / fpp(x)
        if (abs(newx - x) < eps) or (abs(fp(x)) < eps):
            finished = true
        x = newx
    return x

︡f93fd865-82cb-4c88-810a-e7f340c977c1︡{"done":true}
︠9b903f9e-6dfd-4a19-9c20-0fd6b62aaddcs︠

︡321e734c-44cc-4a82-961f-d14173d4e041︡{"done":true}
︠877deb0d-deb2-4816-abad-6d10aafbcd07s︠

︡ba480b1b-2471-436f-81a9-6aa9424cb40c︡{"done":true}
︠58770e6c-4df2-4ef8-9978-c9df91464c62s︠
g(x) = x^4 - 3*x^3 + 2*x^2
︡1e3b0ea2-578d-4978-a9de-3e792f69c228︡{"done":true}
︠27e78e5b-8fea-4215-840e-a26c891361bbs︠
plot(g, -1,2)
︡5d2d7f98-3795-412a-845c-4af14c06acbf︡{"file":{"filename":"/home/user/.sage/temp/project-51860a46-5954-40bb-a777-ddd70c231dbc/298/tmp_dlUvMS.svg","show":true,"text":null,"uuid":"0fd7005c-4708-490c-86c2-780c2bb50830"},"once":false}︡{"done":true}
︠d5e24ceb-c228-4978-a978-3b5dde6c8308s︠
dichotomous_search(g, 1, 2, 1e-4, 1e-5)
︡6569c735-4601-4459-a522-54652d98772b︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1188, in execute\n    flags=compile_flags), namespace, locals)\n  File \"\", line 1, in <module>\nNameError: name 'dichotomous_search' is not defined\n"}︡{"done":true}
︠d7f4cc02-cdba-431b-ad0c-7caedfd9cd3cs︠
newtons_method(g, 1.3, 1e-6)
︡8ae472ce-ed10-4c4a-806e-c89ed011ae1c︡{"stdout":"1.64038820320221\n"}︡{"done":true}
︠2566820a-948e-4742-809a-07d3d66179e3s︠
newtons_method(g, 0.8, 1e-6)
︡e0a3d1d4-f579-41e9-9c1e-dfb3d4064203︡{"stdout":"0.609611796797793\n"}︡{"done":true}
︠3274a6fa-6f7a-4923-af28-7b1be8873e5cs︠
golden_section(g, 1, 2, 1e-4)
︡b872aca1-7fca-4b64-bc55-9342c06065e4︡{"stdout":"1.64040730584972\n"}︡{"done":true}
︠c1915659-e7db-4e74-9348-994d6c44ea0es︠
︡8f5cc300-0494-42c0-a6a5-51609e7e80f0︡{"done":true}









